/*

    ivscale -- a C/Python module providing a gtk vscale with the 
               maximum at the top

    Copyright (C) 1999  Eric S. Tiedemann

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact: Eric S. Tiedemann, est@hyperreal.org

*/

#ifndef __IVSCALE_H__
#define __IVSCALE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define IVSCALE(obj)          GTK_CHECK_CAST (obj, ivscale_get_type (), Ivscale)
#define IVSCALE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, ivscale_get_type(), IvscaleClass)
#define IS_IVSCALE(obj)       GTK_CHECK_TYPE (obj, ivscale_get_type ())


typedef struct _Ivscale       Ivscale;
typedef struct _IvscaleClass  IvscaleClass;

struct _Ivscale
{
  GtkVBox vbox;
  char fmt[100];
  GtkAdjustment *adj;
  GtkAdjustment *adj1;
  GtkWidget *vs;
  GtkWidget *l;
  gint sigid;
};

struct _IvscaleClass
{
  GtkVBoxClass parent_class;
};

guint          ivscale_get_type        (void);
GtkWidget*     ivscale_new             (GtkAdjustment *);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* __IVSCALE_H__ */
