
// generated by ButterJamGen.py

extern "C"
{
#include <stddef.h>
#include <stdio.h>
#include <math.h>
}

#ifndef M_PI
#define M_PI 3.14159
#endif


class ButterJam2x3
{
 public:

  enum type {NONE, LOWPASS, BANDPASS, HIGHPASS};

 private:

  float c0x0;
  float c0x1;
  float c0f0y0;
  float c0f0y1;
  float c0f0a0;
  float c0f0a1;
  float c0f0a2;
  float c0f0b0;
  float c0f0b1;
  enum type c0f0t;
  float c0f0level;
  float c0f1y0;
  float c0f1y1;
  float c0f1a0;
  float c0f1a1;
  float c0f1a2;
  float c0f1b0;
  float c0f1b1;
  enum type c0f1t;
  float c0f1level;
  float c0f2y0;
  float c0f2y1;
  float c0f2a0;
  float c0f2a1;
  float c0f2a2;
  float c0f2b0;
  float c0f2b1;
  enum type c0f2t;
  float c0f2level;
  float c1x0;
  float c1x1;
  float c1f0y0;
  float c1f0y1;
  float c1f0a0;
  float c1f0a1;
  float c1f0a2;
  float c1f0b0;
  float c1f0b1;
  enum type c1f0t;
  float c1f0level;
  float c1f1y0;
  float c1f1y1;
  float c1f1a0;
  float c1f1a1;
  float c1f1a2;
  float c1f1b0;
  float c1f1b1;
  enum type c1f1t;
  float c1f1level;
  float c1f2y0;
  float c1f2y1;
  float c1f2a0;
  float c1f2a1;
  float c1f2a2;
  float c1f2b0;
  float c1f2b1;
  enum type c1f2t;
  float c1f2level;

 public:

  const float sr;

  ButterJam2x3(float sr);
  void adjust(size_t channel, size_t filter, float level, 
	      enum type t, float f, float q=0);
  void adjust(size_t channel, size_t filter, float level);
  void go(float *in, float *out, size_t nsamps);
};
ButterJam2x3::ButterJam2x3(float sr)
 : sr(sr)
{
c0x0 = 0;
c0x1 = 0;
c0f0t = NONE;
c0f0level = 0;
c0f0y0 = 0;
c0f0y1 = 0;
c0f1t = NONE;
c0f1level = 0;
c0f1y0 = 0;
c0f1y1 = 0;
c0f2t = NONE;
c0f2level = 0;
c0f2y0 = 0;
c0f2y1 = 0;
c1x0 = 0;
c1x1 = 0;
c1f0t = NONE;
c1f0level = 0;
c1f0y0 = 0;
c1f0y1 = 0;
c1f1t = NONE;
c1f1level = 0;
c1f1y0 = 0;
c1f1y1 = 0;
c1f2t = NONE;
c1f2level = 0;
c1f2y0 = 0;
c1f2y1 = 0;
}

void
ButterJam2x3::adjust(size_t channel, size_t filter, float level)
{
switch (channel)
{
case 0:
switch (filter)
{
case 0:
c0f0level = level;
break;
case 1:
c0f1level = level;
break;
case 2:
c0f2level = level;
break;
}
break;
case 1:
switch (filter)
{
case 0:
c1f0level = level;
break;
case 1:
c1f1level = level;
break;
case 2:
c1f2level = level;
break;
}
break;
}
}


void
ButterJam2x3::adjust(size_t channel, size_t filter, float level, enum type newt, float f, float q=0)
{
switch (channel)
{
case 0:
switch (filter)
{
case 0:
c0f0t = newt;

  c0f0level = level;
  
  switch (newt)
    {
    case NONE: 
      // make SURE this never outputs anything
      c0f0level = 0;
      break;
    case LOWPASS:
      {
	float C = 1.0 / tan(M_PI * f / sr);

	c0f0a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c0f0a1 = 2.0 * c0f0a0;
	c0f0a2 = c0f0a0;
	
	c0f0b0 = 2 * (1.0 - C * C) * c0f0a0;
	c0f0b1 = (1.0 - sqrt(2.0) * C + C * C) * c0f0a0;
      }
      break;
    case BANDPASS:
      {
	float C = 1.0 / tan(M_PI * q / sr);
	float D = 2 * cos(2 * M_PI * f / sr);

	c0f0a0 = 1.0 / (1.0 + C);
	c0f0a1 = 0.0;
	c0f0a2 = -c0f0a0;

	c0f0b0 = -C * D * c0f0a0;
	c0f0b1 = (C - 1.0) * c0f0a0;
      }
      break;
    case HIGHPASS:
      {
	float C = tan(M_PI * f / sr);

	c0f0a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c0f0a1 = -2.0 * c0f0a0;
	c0f0a2 = c0f0a0;

	c0f0b0 = 2 * (C * C - 1.0) * c0f0a0;
	c0f0b1 = (1.0 - sqrt(2.0) * C + C * C) * c0f0a0;
      }
      break;
    }

break;
case 1:
c0f1t = newt;

  c0f1level = level;
  
  switch (newt)
    {
    case NONE: 
      // make SURE this never outputs anything
      c0f1level = 0;
      break;
    case LOWPASS:
      {
	float C = 1.0 / tan(M_PI * f / sr);

	c0f1a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c0f1a1 = 2.0 * c0f1a0;
	c0f1a2 = c0f1a0;
	
	c0f1b0 = 2 * (1.0 - C * C) * c0f1a0;
	c0f1b1 = (1.0 - sqrt(2.0) * C + C * C) * c0f1a0;
      }
      break;
    case BANDPASS:
      {
	float C = 1.0 / tan(M_PI * q / sr);
	float D = 2 * cos(2 * M_PI * f / sr);

	c0f1a0 = 1.0 / (1.0 + C);
	c0f1a1 = 0.0;
	c0f1a2 = -c0f1a0;

	c0f1b0 = -C * D * c0f1a0;
	c0f1b1 = (C - 1.0) * c0f1a0;
      }
      break;
    case HIGHPASS:
      {
	float C = tan(M_PI * f / sr);

	c0f1a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c0f1a1 = -2.0 * c0f1a0;
	c0f1a2 = c0f1a0;

	c0f1b0 = 2 * (C * C - 1.0) * c0f1a0;
	c0f1b1 = (1.0 - sqrt(2.0) * C + C * C) * c0f1a0;
      }
      break;
    }

break;
case 2:
c0f2t = newt;

  c0f2level = level;
  
  switch (newt)
    {
    case NONE: 
      // make SURE this never outputs anything
      c0f2level = 0;
      break;
    case LOWPASS:
      {
	float C = 1.0 / tan(M_PI * f / sr);

	c0f2a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c0f2a1 = 2.0 * c0f2a0;
	c0f2a2 = c0f2a0;
	
	c0f2b0 = 2 * (1.0 - C * C) * c0f2a0;
	c0f2b1 = (1.0 - sqrt(2.0) * C + C * C) * c0f2a0;
      }
      break;
    case BANDPASS:
      {
	float C = 1.0 / tan(M_PI * q / sr);
	float D = 2 * cos(2 * M_PI * f / sr);

	c0f2a0 = 1.0 / (1.0 + C);
	c0f2a1 = 0.0;
	c0f2a2 = -c0f2a0;

	c0f2b0 = -C * D * c0f2a0;
	c0f2b1 = (C - 1.0) * c0f2a0;
      }
      break;
    case HIGHPASS:
      {
	float C = tan(M_PI * f / sr);

	c0f2a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c0f2a1 = -2.0 * c0f2a0;
	c0f2a2 = c0f2a0;

	c0f2b0 = 2 * (C * C - 1.0) * c0f2a0;
	c0f2b1 = (1.0 - sqrt(2.0) * C + C * C) * c0f2a0;
      }
      break;
    }

break;
}
break;
case 1:
switch (filter)
{
case 0:
c1f0t = newt;

  c1f0level = level;
  
  switch (newt)
    {
    case NONE: 
      // make SURE this never outputs anything
      c1f0level = 0;
      break;
    case LOWPASS:
      {
	float C = 1.0 / tan(M_PI * f / sr);

	c1f0a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c1f0a1 = 2.0 * c1f0a0;
	c1f0a2 = c1f0a0;
	
	c1f0b0 = 2 * (1.0 - C * C) * c1f0a0;
	c1f0b1 = (1.0 - sqrt(2.0) * C + C * C) * c1f0a0;
      }
      break;
    case BANDPASS:
      {
	float C = 1.0 / tan(M_PI * q / sr);
	float D = 2 * cos(2 * M_PI * f / sr);

	c1f0a0 = 1.0 / (1.0 + C);
	c1f0a1 = 0.0;
	c1f0a2 = -c1f0a0;

	c1f0b0 = -C * D * c1f0a0;
	c1f0b1 = (C - 1.0) * c1f0a0;
      }
      break;
    case HIGHPASS:
      {
	float C = tan(M_PI * f / sr);

	c1f0a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c1f0a1 = -2.0 * c1f0a0;
	c1f0a2 = c1f0a0;

	c1f0b0 = 2 * (C * C - 1.0) * c1f0a0;
	c1f0b1 = (1.0 - sqrt(2.0) * C + C * C) * c1f0a0;
      }
      break;
    }

break;
case 1:
c1f1t = newt;

  c1f1level = level;
  
  switch (newt)
    {
    case NONE: 
      // make SURE this never outputs anything
      c1f1level = 0;
      break;
    case LOWPASS:
      {
	float C = 1.0 / tan(M_PI * f / sr);

	c1f1a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c1f1a1 = 2.0 * c1f1a0;
	c1f1a2 = c1f1a0;
	
	c1f1b0 = 2 * (1.0 - C * C) * c1f1a0;
	c1f1b1 = (1.0 - sqrt(2.0) * C + C * C) * c1f1a0;
      }
      break;
    case BANDPASS:
      {
	float C = 1.0 / tan(M_PI * q / sr);
	float D = 2 * cos(2 * M_PI * f / sr);

	c1f1a0 = 1.0 / (1.0 + C);
	c1f1a1 = 0.0;
	c1f1a2 = -c1f1a0;

	c1f1b0 = -C * D * c1f1a0;
	c1f1b1 = (C - 1.0) * c1f1a0;
      }
      break;
    case HIGHPASS:
      {
	float C = tan(M_PI * f / sr);

	c1f1a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c1f1a1 = -2.0 * c1f1a0;
	c1f1a2 = c1f1a0;

	c1f1b0 = 2 * (C * C - 1.0) * c1f1a0;
	c1f1b1 = (1.0 - sqrt(2.0) * C + C * C) * c1f1a0;
      }
      break;
    }

break;
case 2:
c1f2t = newt;

  c1f2level = level;
  
  switch (newt)
    {
    case NONE: 
      // make SURE this never outputs anything
      c1f2level = 0;
      break;
    case LOWPASS:
      {
	float C = 1.0 / tan(M_PI * f / sr);

	c1f2a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c1f2a1 = 2.0 * c1f2a0;
	c1f2a2 = c1f2a0;
	
	c1f2b0 = 2 * (1.0 - C * C) * c1f2a0;
	c1f2b1 = (1.0 - sqrt(2.0) * C + C * C) * c1f2a0;
      }
      break;
    case BANDPASS:
      {
	float C = 1.0 / tan(M_PI * q / sr);
	float D = 2 * cos(2 * M_PI * f / sr);

	c1f2a0 = 1.0 / (1.0 + C);
	c1f2a1 = 0.0;
	c1f2a2 = -c1f2a0;

	c1f2b0 = -C * D * c1f2a0;
	c1f2b1 = (C - 1.0) * c1f2a0;
      }
      break;
    case HIGHPASS:
      {
	float C = tan(M_PI * f / sr);

	c1f2a0 = 1.0 / (1.0 + sqrt(2.0) * C + C * C);
	c1f2a1 = -2.0 * c1f2a0;
	c1f2a2 = c1f2a0;

	c1f2b0 = 2 * (C * C - 1.0) * c1f2a0;
	c1f2b1 = (1.0 - sqrt(2.0) * C + C * C) * c1f2a0;
      }
      break;
    }

break;
}
break;
}
}


void
ButterJam2x3::go(float *in, float *out, size_t nsamps)
{
  //fprintf(stderr, "%f:%f\n", c0f2level, c1f2level);

  for (size_t i = 0; i < nsamps; i++)
  {
    float v, in1, out1;
    v = 0;
    in1 = *in++;
    out1 = c0f0a0 * in1 + c0f0a1 * c0x0
		+ c0f0a2 * c0x1
		- c0f0b0 * c0f0y0 - c0f0b1 * c0f0y1;
	      
	      c0x1 = c0x0;
              c0x0 = in1;
              c0f0y1 = c0f0y0;
              c0f0y0 = out1;
	      
	      v += out1 * c0f0level;
    out1 = c0f1a0 * in1 + c0f1a1 * c0x0
		+ c0f1a2 * c0x1
		- c0f1b0 * c0f1y0 - c0f1b1 * c0f1y1;
	      
	      c0x1 = c0x0;
              c0x0 = in1;
              c0f1y1 = c0f1y0;
              c0f1y0 = out1;
	      
	      v += out1 * c0f1level;
    out1 = c0f2a0 * in1 + c0f2a1 * c0x0
		+ c0f2a2 * c0x1
		- c0f2b0 * c0f2y0 - c0f2b1 * c0f2y1;
	      
	      c0x1 = c0x0;
              c0x0 = in1;
              c0f2y1 = c0f2y0;
              c0f2y0 = out1;
	      
	      v += out1 * c0f2level;
    *out++ = v;
    v = 0;
    in1 = *in++;
    out1 = c1f0a0 * in1 + c1f0a1 * c1x0
		+ c1f0a2 * c1x1
		- c1f0b0 * c1f0y0 - c1f0b1 * c1f0y1;
	      
	      c1x1 = c1x0;
              c1x0 = in1;
              c1f0y1 = c1f0y0;
              c1f0y0 = out1;
	      
	      v += out1 * c1f0level;
    out1 = c1f1a0 * in1 + c1f1a1 * c1x0
		+ c1f1a2 * c1x1
		- c1f1b0 * c1f1y0 - c1f1b1 * c1f1y1;
	      
	      c1x1 = c1x0;
              c1x0 = in1;
              c1f1y1 = c1f1y0;
              c1f1y0 = out1;
	      
	      v += out1 * c1f1level;
    out1 = c1f2a0 * in1 + c1f2a1 * c1x0
		+ c1f2a2 * c1x1
		- c1f2b0 * c1f2y0 - c1f2b1 * c1f2y1;
	      
	      c1x1 = c1x0;
              c1x0 = in1;
              c1f2y1 = c1f2y0;
              c1f2y0 = out1;
	      
	      v += out1 * c1f2level;
    *out++ = v;
  }
}
